using REG_MARK_LIB;
namespace UnitTests
{
    /// <summary>
    ///    
    /// </summary>
    public class TestsOfLowDifficult
    {

        //   GetNextMarkAfter,       
        [Fact]
        public void TestGetNextMarkAfterWithCorrectData()
        {
            Assert.Equal("T357CK42", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("T356CK42"));
        }
        //   GetNextMarkAfter,        
        [Fact]
        public void TestGetNextMarkAfterWithCorrectDataOnFirstLetter()
        {
            Assert.Equal("Y001OK52", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("T999OK52"));
        }
        //   CheckMark,   
        [Fact]
        public void TestMarkWithCorrectDataCheck()
        {
            Assert.True(REG_MARK_LIB.REG_MARK_LIB.CheckMark("a999aa99"));
        }
        //   GetNextMarkAfterInRange,        ()
        [Fact]
        public void TestGetNextMarkAfterInRangeWithIncorrectDataBiggerThanEnd()
        {
            Assert.Equal("out of stock", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfterInRange("X999YX52", "A001AA52", "X999OX52"));
        }
        //   GetNextMarkAfterInRange,   
        [Fact]
        public void TestGetNextMarkAfterInRangeWithIncorrectDataIncorrectBounds()
        {
            Assert.Equal("out of stock", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfterInRange("X999YX52", "X999OX52", "A001AA52"));
        }
        //   CheckMark,   
        [Fact]
        public void TestMarkWithIncorrectDataCheckOnSecondNumber()
        {
            Assert.False(REG_MARK_LIB.REG_MARK_LIB.CheckMark("a999aa999"));
        }
        //   GetNextMarkAfter,        
        [Fact]
        public void TestGetNextMarkAfterWithCorrectDataOnThirdLetter()
        {
            Assert.Equal("A001OM42", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("X999OK42"));
        }
        //   GetNextMarkAfterInRange,        ()
        [Fact]
        public void TestGetNextMarkAfterInRangeWithIncorrectDataSmallerThanStart()
        {
            Assert.Equal("out of stock", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfterInRange("A003OM42", "X999OX52", "X999XX52"));
        }
        //   GetCombinationsCountInRange,   
        [Fact]
        public void TestGetCombinationsCountInRangeWithCorrectData()
        {
            Assert.Equal(2, REG_MARK_LIB.REG_MARK_LIB.GetCombinationsCountInRange("M356OK52", "M357OK52"));
        }
        //   GetCombinationsCountInRange,   
        [Fact]
        public void TestGetCombinationsCountInRangeWithCorrectDataReverse()
        {
            Assert.Equal(2, REG_MARK_LIB.REG_MARK_LIB.GetCombinationsCountInRange("M357OK52", "M356OK52"));
        }
        //   GetCombinationsCountInRange,   
        [Fact]
        public void TestGetCombinationsCountInRangeWithCorrectDataEqualsBounds()
        {
            Assert.Equal(1, REG_MARK_LIB.REG_MARK_LIB.GetCombinationsCountInRange("M356OK52", "M356OK52"));
        }
        //   GetNextMarkAfter,        
        [Fact]
        public void TestGetNextMarkAfterWithCorrectDataOnSecondLetter()
        {
            Assert.Equal("A001OM42", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("X999OK42"));
        }
        //   GetNextMarkAfterInRange,   
        [Fact]
        public void TestGetNextMarkAfterInRangeWithCorrectData()
        {
            Assert.Equal("A001PA42", REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfterInRange("X999OX42", "A001AA42", "X999XX42"));
        }
    }

    /// <summary>
    ///    
    /// </summary>
    public class TestsOfHighDifficult
    {
        //   CheckMark,   null
        [Fact]
        public void TestCheckMarkOnNull()
        {
            Assert.Throws<ArgumentNullException>(() => REG_MARK_LIB.REG_MARK_LIB.CheckMark(null));
        }
        //   GetNextMarkAfterInRange,    
        [Fact]
        public void TestGetNextMarkAfterInRangeOnNotMark()
        {
            Assert.Throws<ArgumentException>(() => REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfterInRange("Hello world!", "a999aa42", "a999aa42"));
        }
        //   GetNextMarkAfter,   ,     
        [Fact]
        public void TestGetNextMarkAfterOnNotNextMark()
        {
            Assert.Throws<Exception>(() => REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("x999xx42"));
        }
        //   GetNextMarkAfter,    
        [Fact]
        public void TestGetNextMarkAfterOnNotMark()
        {
            Assert.Throws<ArgumentException>(() => REG_MARK_LIB.REG_MARK_LIB.GetNextMarkAfter("Hello world!"));
        }
        //   GetCombinationsCountInRange,    
        [Fact]
        public void TestGetCombinationsCountInRangeOnNotMark()
        {
            Assert.Throws<ArgumentException>(() => REG_MARK_LIB.REG_MARK_LIB.GetCombinationsCountInRange("Hello world!", "a999aa42"));
        }
    }
}